/*------------------------------------------------------------------
chaotisches Verschluesselungsprogramm fuer Dateien

(c) 2002 Ulrich Kritzner
Die Verbreitung dieser Datei unterliegt der GNU General Public License.

Copyright 2002 by Ulrich Kritzner.
Redistribution of this file is permitted under the GNU General Public License.

Dieses Programm verschl&uuml;sselt Dateien mit XOR

Verschl&uuml;sseln: cryptfil -e unverschluesselte_datei verschluesselte_datei password
Entschl&uuml;sseln: cryptfil -d verschluesselte_datei unverschluesselte_datei password
------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>

#include "include/cryptx1k.h"

#define _MY_LEN 4096

int help(void)
{
  printf("arguments:\n");
  printf("   source file\n");
  printf("   destination file\n");
  printf("   password\n");
  return 0;
}

int main(int _argc,char *_argv[])
{
  FILE *in=NULL,*out=NULL;
  __u32 len,countin=0,countout=0;
  char *s;
  __u32 data[256];
  random_seed seed;
  printf("\n\nxor encrypting/decrypting of files\n");
  printf("(c)2000 Ulrich Kritzner\n");
  printf("---\n");
  if (_argc!=4)
    return help();
  in=fopen(_argv[1],"rb");
  if (in!=NULL)
    out=fopen(_argv[2],"wb");
  if ((in==NULL)||(out==NULL)) {
    printf("mad mad error\n");
    if (in==NULL)
      printf("invalid source filename: %s\n",_argv[1]);
    else
      printf("invalid destination filename: %s\n",_argv[2]);
    if (in!=NULL)
      fclose(in);
    if (out!=NULL)
      fclose(out);
    printf("---\n");
    return help();
  }
  s=(char*)malloc(_MY_LEN);
  random_initseed(&seed,_argv[3],0,128);
  crypt_initdatax1024(&seed,&data[0],256);
  printf("encoding... ");
  do {
    len=fread((void *)s,1,_MY_LEN,in);
    countin+=len;
    crypt_blockx1024(&data[0],s,len);
    countout+=fwrite((void *)s,1,len,out);
  } while ((len==_MY_LEN)&&(countin==countout));
  printf("%i of %i bytes\n",(int)countout,(int)countin);
  fclose(in);
  fclose(out);
  free(s);
  if (countin!=countout) {
    printf("error: destination file incomplete\n",_argv[2]);
    return 0;
  }
  return 1;
}
