#ifndef DROEPPEZ_CRYPT_X_1024
#define DROEPPEZ_CRYPT_X_1024

/*------------------------------------------------------------------
chaotische Verschluesselungsmaschine fuer Datensaetze beliebiger Laenge
mit einem Schluessel von 1024 Bytes Laenge

(c) 2002 Ulrich Kritzner
Die Verbreitung dieser Datei unterliegt der GNU General Public License.

Copyright 2002 by Ulrich Kritzner.
Redistribution of this file is permitted under the GNU General Public License.

Achtung: nur XOR-Verschluesselung
------------------------------------------------------------------*/

#define _CRYPT_BLOCKLEN_LB 256
#define _CRYPT_BLOCKMASK_LB 255 
#define _CRYPT_BLOCKLEN_XB 1024
#define _CRYPT_BLOCKMASK_XB 1023 

#include "u_random.h"

/* Deklarationen ----------------------------------- */

void crypt_initdatax1024(random_seed *seed,__u32 *data,__u32 loops1);
/* initialisiert einen Codierungsschluessel
     seed:   Zufallssaat
     data:   Codierungsschluessel
     loops1: Anzahl der Einschwingzyklen */

void crypt_blockx1024(__u32 *data,char *b,__u32 len);
/* Codiert einen 1024-Byte-Block
     data: Codierungsschluessel
     b:    Daten */

/* Prozeduren -------------------------------------- */

void crypt_initdatax1024(random_seed *seed,__u32 *data,__u32 loops1)
{
  __u16 i;
  __u8 *thexor;
  thexor=(__u8*)&data[0];
  random_loops(seed,loops1);
  for (i=0;i<_CRYPT_BLOCKLEN_XB;i++)
    thexor[i]=(__u8)((__u16)random_random(seed)&0xFF);
}

void crypt_blockx1024(__u32 *data,char *b,__u32 len)
{
  __u32 i,n;
  __u32 *block;
  __u8 *thexor;
  thexor=(__u8*)&data[0];
  block=(__u32*) b;
  for (i=0;i<len>>2;i++)
    block[i]=block[i]^data[i&_CRYPT_BLOCKMASK_LB];
  n=i<<2;
  for (i=n;i<len;i++)
    b[i]=b[i]^thexor[i&_CRYPT_BLOCKMASK_XB];
}

#endif
