#ifndef DROEPPEZ_U_RANDOM
#define DROEPPEZ_U_RANDOM
#include "u_types.h"

/*------------------------------------------------------------------
Zufallszahlengenerator

(c) 2002 Ulrich Kritzner
Die Verbreitung dieser Datei unterliegt der GNU General Public License.

Copyright 2002 by Ulrich Kritzner.
Redistribution of this file is permitted under the GNU General Public License.
------------------------------------------------------------------*/

#ifndef _RANDOM_PASSWLEN
#define _RANDOM_PASSWLEN 128
#endif

typedef struct{__u8 n,i;__u32 x;__u16 seed[_RANDOM_PASSWLEN];} random_seed;
/* Datengrundlage fuer die Zufallszahlenbildung
     n:    relevante Anzahl der Saatzahlen
     i:    aktuelle Stelle der Saataufnahme
     x:    aktueller Wert des globalen Saatwertes
     seed: Feld der Saatzahlen */

void random_initseed(random_seed *seed,char *passwd,__u16 y,__u32 loops);
/* initialisiert eine Zufallssaat
     seed:   Zufallssaat
     passwd: Zeichenkette Password
     y:      Anfangswert gobale Saat
     loops:  Einschwingzyklen */
void random_initseed16(random_seed *seed,__u16 *init,__u16 linit,__u16 y,__u32 loops);
/* initialisiert eine Zufallssaat
     seed:   Zufallssaat
     init:   Initialisierungswertefeld
     linit:  Laenge des Initialisierungswertefeldes
     y:      Anfangswert gobale Saat
     loops:  Einschwingzyklen */
__u16 random_random(random_seed *data);
/* berechnet eine neue Pseudo-Zufallszahl */
void random_loops(random_seed *seed,__u32 loops);
/* laesst die Zufallszahlensaat loops Zyklen Schwingen */

void random_initseed(random_seed *seed,char *passwd,__u16 y,__u32 loops)
{
  __u16 i,n;
  for (n=0;(n<_RANDOM_PASSWLEN)&&(passwd[n]!=0);n++);
  seed->x=y;
  for (i=0;i<n;i++)
  {
    seed->seed[i]=passwd[i]<<2;
    seed->x+=seed->seed[i];
  }
  seed->n=(__u8)n;
  seed->i=0;
  random_loops(seed,loops+n*2);
}

void random_initseed16(random_seed *seed,__u16 *init,__u16 linit,__u16 y,__u32 loops)
{
  __u16 i,n;
  n=linit;
  if (n>_RANDOM_PASSWLEN)
    n=_RANDOM_PASSWLEN;
  seed->x=y;
  for (i=0;i<n;i++)
  {
    seed->seed[i]=init[i];
    seed->x+=seed->seed[i];
  }
  seed->n=(__u8)n;
  seed->i=0;
  random_loops(seed,loops+n*2);
}

__u16 random_random(random_seed *data)
{
  __u32 y;
  data->i%=data->n;
  y=data->x&0xFFFF;
  y=(__u32)(y*(65535-y))>>13;
  data->x-=data->seed[data->i];
  data->seed[data->i]=y;
  data->x+=y;
  data->i++;
  return (__u16)y;
}

void random_loops(random_seed *seed,__u32 loops)
{
  __u32 i;
  for (i=0;i<loops;i++)
    random_random(seed);
}

#endif
